#include <htc.h>
#include <pic18f4550.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "usart.h"

#define FREQ 18432000    // Frequency = 18,432MHz
#define baud 9600
#define spbrg_value (((FREQ/64)/baud)-1)    // Refer to the formula for Baud rate calculation in Description tab


unsigned char buf[32]="";
unsigned int count=0;


void main(void)
{
  // PORT A
  LATA = 0b00000000;
  TRISA = 0b00000000;    // Alle Ports sind Ausgnge

  // PORT B
  LATB = 0b00000000;
  TRISB = 0b00000000;    // Alle Ports sind Ausgnge

  TRISCbits.TRISC7=1; //Make UART RX pin input
  TRISCbits.TRISC6=1; //Make UART TX pin output

  initUSART(spbrg_value);

  putsUSART("Hallo "); // Funktioniert und kommt am pc ohne fehler an
  putsUSART("TEST"); // Funktioniert und kommt am pc ohne fehler an

  while(1)
  {
    unsigned char usartin = getcUSART(); // Funktioniert
    if ( usartin != 0 ) {
      if (usartin=='\r') { // Funktioniert wird aufgerufen
          buf[count] = '\0';
          putsUSART(buf); // Geht nicht
          count=0;
      } else {         
          writeUSART(usartin); // Funktioniert und kommt am pc ohne fehler an
          buf[count] = usartin; // Scheint nicht zu funktonieren.. WARUM????
          writeUSART(buf[count]);
          count++;
      }
    }
    if(count == 32) { count = 0; }
  }
}

/*void delay( int ms ) {
  //1 ms = 4608 Befehlstakte (18,432 MHz Quarz / 4)
  for(int i=0; i<ms; i++ ) {
    _delay(4608);
  }
}*/